-- Test edit_campsite_type_feature
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(13);

set search_path to camper, public;

select has_function('camper', 'edit_campsite_type_feature', array['integer', 'text', 'text']);
select function_lang_is('camper', 'edit_campsite_type_feature', array['integer', 'text', 'text'], 'sql');
select function_returns('camper', 'edit_campsite_type_feature', array['integer', 'text', 'text'], 'integer');
select isnt_definer('camper', 'edit_campsite_type_feature', array['integer', 'text', 'text']);
select volatility_is('camper', 'edit_campsite_type_feature', array['integer', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'edit_campsite_type_feature', array ['integer', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'edit_campsite_type_feature', array ['integer', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'edit_campsite_type_feature', array ['integer', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'edit_campsite_type_feature', array ['integer', 'text', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_type_feature_i18n cascade;
truncate campsite_type_feature cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (campsite_type_id, company_id, media_id, name, description, active, max_campers, bookable_nights)
values (3, 1, 2, 'Type A', '<p>A</p>', true, 4, '[1, 7]')
;

insert into campsite_type_feature (campsite_type_feature_id, campsite_type_id, icon_name, name)
values (4, 3, 'information', 'Feature 1')
     , (5, 3, 'wifi', 'Feature 2')
;

select lives_ok(
	$$ select edit_campsite_type_feature(4, 'toilet', 'Feature A') $$,
	'Should be able to edit the first feature'
);

select lives_ok(
	$$ select edit_campsite_type_feature(5, 'baby', 'Feature B') $$,
	'Should be able to edit the second feature'
);

select bag_eq(
	$$ select campsite_type_feature_id, campsite_type_id, icon_name, name from campsite_type_feature $$,
	$$ values (4, 3, 'toilet', 'Feature A')
	        , (5, 3, 'baby', 'Feature B')
	$$,
	'Should have updated all campsite type features.'
);

select is_empty(
	$$ select * from campsite_type_feature_i18n $$,
	'Should not have added any translation for campsite type features.'
);


select *
from finish();

rollback;
